<?php
if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

/**
 * Displays ministries.
 *
 * @param 
 * @param 
 *
 * @author andy_moyle
 * 
 */
function church_admin_ministries_list()
{
    $ministries=church_admin_ministries('None');
    echo'<p><a class="button-primary" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_ministry&tab=ministries','edit_ministry').'">'.__('Add a ministry','church-admin').'</a> <a class="button-secondary" href="'.wp_nonce_url(site_url().'/?download=ministries_pdf','ministries_pdf').'">'.__('Ministries PDF','church-admin').'</a></p>';
    if(!empty($ministries))
    {
        echo'<table class="widefat striped"><thead><tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Ministry (Click to view people)','church-admin').'</th><th>'.__('Shortcode','church-admin').'</th></tr></thead><tfoot><tr><th>'.__('Edit','church-admin').'</th><th>'.__('Delete','church-admin').'</th><th>'.__('Ministry','church-admin').'</th><th>'.__('Shortcode','church-admin').'</th></tr></tr></tfoot><tbody>';
        foreach($ministries AS $id=>$ministry)
        {
            church_admin_ministry_tr($id,$ministry);
            
        }
        echo'</tbody></table>';
    }

}
function church_admin_ministry_tr($id,$ministry)
{
		$edit='<a href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=edit_ministry&amp;id='.$id,'edit_ministry').'">'.__('Edit','church-admin').'</a>';
            if($id!=1){$delete='<a onclick="return confirm(\''.__('Are you sure?','church-admin').'\');" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=delete_ministry&amp;id='.$id,'delete_ministry').'">'.__('Delete','church-admin').'</a>';}else{$delete=__("Can't be deleted",'church-admin');}
        $view='<a title="'.__('View people doing that ministry','church-admin').'" href="'.wp_nonce_url('admin.php?page=church_admin/index.php&amp;action=view_ministry&amp;id='.$id,'view_ministry').'">'.esc_html($ministry).'</a>';
            
			echo'<tr><td>'.$edit.'</td><td>'.$delete.'</td><td>'.$view.'</td><td>[church_admin type="ministries" ministry_id='.esc_html($id).']</td></td></tr>';
			$child=church_admin_ministries($id);
            if(!empty($child))
            {
            	foreach($child AS $id=>$ministry)church_admin_ministry_tr($id,$ministry);
            }
}

function church_admin_view_ministry($id)
{
		echo'<p><a href="'.wp_nonce_url("admin.php?page=church_admin/index.php&amp;action=ministry_list",'ministry_list').'">'.__('Ministry List','church-admin').'</a></p>';
		global $wpdb;
		$ministries=church_admin_ministries();
		$sql='SELECT CONCAT_WS(" ",a.first_name,a.last_name) AS name, a.people_id FROM '.CA_PEO_TBL.' a, '.CA_MET_TBL.' b WHERE a.people_id=b.people_id AND b.ID="'.esc_sql($id).'" AND b.meta_type="ministry" ORDER BY a.last_name ASC';
		
		$results=$wpdb->get_results($sql);
		if(!empty($_POST))
		{
			//delete people from that ministry
			if(!empty($_POST['remove'])){
			
				foreach($_POST['remove'] AS $key=>$value) $wpdb->query('DELETE FROM '.CA_MET_TBL.' WHERE meta_type="ministry" AND ID="'.esc_sql($id).'" AND people_id="'.esc_sql($value).'"');
			}
			//add people to ministry
			$peoples_id=maybe_unserialize(church_admin_get_people_id($_POST['people']));
			if(!empty($peoples_id)) {
					foreach($peoples_id AS $key=>$people_id){
						
						$sql='INSERT INTO '.CA_MET_TBL.' (people_id,ID,meta_type)VALUES("'.esc_sql($people_id).'","'.esc_sql($id).'","ministry")';
						$wpdb->query($sql);
					}
				}
		
		}	
	$results=$wpdb->get_results('SELECT CONCAT_WS(" ",a.first_name,a.last_name) AS name, a.people_id FROM '.CA_PEO_TBL.' a, '.CA_MET_TBL.' b WHERE a.people_id=b.people_id AND b.ID="'.esc_sql($id).'" AND b.meta_type="ministry" ORDER BY a.last_name,a.first_name ASC');
		
			echo '<h2>'.sprintf(__('Viewing who is in "%1s" ministry','church-admin'),esc_html($ministries[$id])).'</h2><form action="" method="POST">';
			if(!empty($results))
			{//ministry contains people
				echo'<table class="widefat striped" ><thead><tr><th>'.__('Remove','church-admin').'</th><th>'.__('Person','church-admin').'</th></tr></thead><tbody>';
				foreach($results AS $row)
				{
					$delete='<input type="checkbox" value="'.esc_html($row->people_id).'" name="remove[]"/>';
					echo'<tr><td>'.$delete.'</td><td>'.esc_html($row->name).'</td></tr>';
				}
				echo'</table>';
			}//ministry contains people
			echo'<p>'.church_admin_autocomplete('people','friends','to',NULL).'</p>';
			echo'<p><label>'.__('Add people','church-admin').'</label><input type="hidden" name="view_ministries" value="yes"/><input type="submit" value="'.__('Update','church-admin').'"/></p></form>';
		
		
		require_once(plugin_dir_path(dirname(__FILE__)).'includes/comments.php');
		if(!empty($id))church_admin_show_comments('ministry',	$id);
}
function church_admin_delete_ministry($id)
{
    global $wpdb;
	$wpdb->query(' DELETE FROM '.CA_MIN_TBL.' WHERE ID="'.intval($id).'"');
    //delete ministry from people
    $wpdb->query('DELETE FROM '.CA_MET_TBL.' WHERE ID="'.esc_sql($id).'" AND meta_type="ministry"');
    echo'<div class="updated fade"><p>'.__('Ministries Deleted','church-admin').'</p></div>';
    church_admin_ministries_list();
}



function church_admin_edit_ministry($ID)
{
global $wpdb;
$wpdb->show_errors;
   $ministries=church_admin_ministries();
   
 
   if(empty($ministries)) $ministries=array();
    if(isset($_POST['edit_ministry']))
    {//process
        $dep_name=sanitize_text_field(stripslashes($_POST['ministry_name']));
        $overseer=sanitize_text_field(stripslashes($_POST['overseer']));
        if($id)
        {//update current ministry name
            $wpdb->query('UPDATE '.CA_MIN_TBL.' SET ministry="'.esc_sql($dep_name).'"  WHERE ID="'.esc_sql($ID).'"');
            echo '<div class="updated fade"><p>'.__('Ministries Updated','church-admin').'</p></div>';
        }        
        elseif(!in_array($dep_name,$ministries))
        {//add new one if unique
            $wpdb->query('INSERT INTO '.CA_MIN_TBL.' (ministry) VALUES("'.esc_sql($dep_name).'")');
            echo '<div class="updated fade"><p>'.__('Ministries Updated','church-admin').'</p></div>';
            $ID=$wpdb->insert_id;
        }
        else
        {//not unique or update, so ignore!
           echo '<div class="updated fade"><p>'.__('Ministries Unchanged','church-admin').'</p></div>'; 
        }
        if(!empty($_POST['overseer']))
        {
        	$check=$wpdb->get_var('SELECT childID FROM '.CA_MIN_TBL.' WHERE childID="'.intval($ID).'"');
        	if($check)
        	{//update
        		$wpdb->query('UPDATE '.CA_MIN_TBL.' SET ministry="'.esc_sql($overseer).'" WHERE childID="'.intval($ID).'"');
        		echo '<div class="updated fade"><p>'.$overseer.' '.__('updated','church-admin').'</p></div>'; 
        	}
        	else
        	{
        		$sql='INSERT INTO '.CA_MIN_TBL.' (ministry,childID) VALUES("'.esc_sql($overseer).'","'.intval($ID).'")';
        		
        		$wpdb->query($sql);
        		echo '<div class="updated fade"><p>'.__('Overseer added','church-admin').'</p></div>'; 
        	}
        
        }
        else{$wpdb->query('DELETE FROM '.CA_MIN_TBL.' WHERE childID="'.intval($ID).'"');}
        church_admin_ministries_list();
        
    }//end process
    else
    {//form
        echo'<h2>';
        if($id){echo __('Update','church-admin').' ';}else {echo __('Add','church-admin').' ';}
        echo __('Ministry','church-admin').'</h2>';
        echo'<form action="" method="post"><table class="form-table">';
        echo'<tr><th scope="row">'.__('Ministry Name','church-admin').'</td><td><input type="text" name="ministry_name" ';
        if($ID) echo ' value="'.esc_html($ministries[$ID]).'" ';
        echo'/></td></tr>';
        echo'<tr><th scope="row">'.__('Oversight name','church-admin') .'</td><td><input type="text" name="overseer"  ';
        $check=$wpdb->get_var('SELECT ministry FROM '.CA_MIN_TBL.' WHERE childID="'.esc_sql($ID).'"');
        if($check) echo ' value="'.esc_html($check).'"';
        echo'/></td></tr>';
        echo'</table>';
        
        echo'<p class="submit"><input type="hidden" name="edit_ministry" value="yes"/><input class="button-primary" type="submit" value="'.__('Save Ministry','church-admin').'&raquo;" /></p></form></div>';
        
    }//end form
}
?>